
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Soup.Objects.AuthBasic
    ( 

-- * Exported types
    AuthBasic(..)                           ,
    AuthBasicK                              ,
    toAuthBasic                             ,
    noAuthBasic                             ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Soup.Types
import GI.Soup.Callbacks
import qualified GI.GObject as GObject

newtype AuthBasic = AuthBasic (ForeignPtr AuthBasic)
foreign import ccall "soup_auth_basic_get_type"
    c_soup_auth_basic_get_type :: IO GType

type instance ParentTypes AuthBasic = AuthBasicParentTypes
type AuthBasicParentTypes = '[Auth, GObject.Object]

instance GObject AuthBasic where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_soup_auth_basic_get_type
    

class GObject o => AuthBasicK o
instance (GObject o, IsDescendantOf AuthBasic o) => AuthBasicK o

toAuthBasic :: AuthBasicK o => o -> IO AuthBasic
toAuthBasic = unsafeCastTo AuthBasic

noAuthBasic :: Maybe AuthBasic
noAuthBasic = Nothing

type instance AttributeList AuthBasic = AuthBasicAttributeList
type AuthBasicAttributeList = ('[ '("host", AuthHostPropertyInfo), '("is-authenticated", AuthIsAuthenticatedPropertyInfo), '("is-for-proxy", AuthIsForProxyPropertyInfo), '("realm", AuthRealmPropertyInfo), '("scheme-name", AuthSchemeNamePropertyInfo)] :: [(Symbol, *)])

type instance SignalList AuthBasic = AuthBasicSignalList
type AuthBasicSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


