
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Soup.Objects.AuthDigest
    ( 

-- * Exported types
    AuthDigest(..)                          ,
    AuthDigestK                             ,
    toAuthDigest                            ,
    noAuthDigest                            ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Soup.Types
import GI.Soup.Callbacks
import qualified GI.GObject as GObject

newtype AuthDigest = AuthDigest (ForeignPtr AuthDigest)
foreign import ccall "soup_auth_digest_get_type"
    c_soup_auth_digest_get_type :: IO GType

type instance ParentTypes AuthDigest = AuthDigestParentTypes
type AuthDigestParentTypes = '[Auth, GObject.Object]

instance GObject AuthDigest where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_soup_auth_digest_get_type
    

class GObject o => AuthDigestK o
instance (GObject o, IsDescendantOf AuthDigest o) => AuthDigestK o

toAuthDigest :: AuthDigestK o => o -> IO AuthDigest
toAuthDigest = unsafeCastTo AuthDigest

noAuthDigest :: Maybe AuthDigest
noAuthDigest = Nothing

type instance AttributeList AuthDigest = AuthDigestAttributeList
type AuthDigestAttributeList = ('[ '("host", AuthHostPropertyInfo), '("is-authenticated", AuthIsAuthenticatedPropertyInfo), '("is-for-proxy", AuthIsForProxyPropertyInfo), '("realm", AuthRealmPropertyInfo), '("scheme-name", AuthSchemeNamePropertyInfo)] :: [(Symbol, *)])

type instance SignalList AuthDigest = AuthDigestSignalList
type AuthDigestSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


