
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Soup.Objects.ContentDecoder
    ( 

-- * Exported types
    ContentDecoder(..)                      ,
    ContentDecoderK                         ,
    toContentDecoder                        ,
    noContentDecoder                        ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Soup.Types
import GI.Soup.Callbacks
import qualified GI.GObject as GObject

newtype ContentDecoder = ContentDecoder (ForeignPtr ContentDecoder)
foreign import ccall "soup_content_decoder_get_type"
    c_soup_content_decoder_get_type :: IO GType

type instance ParentTypes ContentDecoder = ContentDecoderParentTypes
type ContentDecoderParentTypes = '[GObject.Object, SessionFeature]

instance GObject ContentDecoder where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_soup_content_decoder_get_type
    

class GObject o => ContentDecoderK o
instance (GObject o, IsDescendantOf ContentDecoder o) => ContentDecoderK o

toContentDecoder :: ContentDecoderK o => o -> IO ContentDecoder
toContentDecoder = unsafeCastTo ContentDecoder

noContentDecoder :: Maybe ContentDecoder
noContentDecoder = Nothing

type instance AttributeList ContentDecoder = ContentDecoderAttributeList
type ContentDecoderAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList ContentDecoder = ContentDecoderSignalList
type ContentDecoderSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


