
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Soup.Objects.RequestData
    ( 

-- * Exported types
    RequestData(..)                         ,
    RequestDataK                            ,
    toRequestData                           ,
    noRequestData                           ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Soup.Types
import GI.Soup.Callbacks
import qualified GI.GObject as GObject
import qualified GI.Gio as Gio

newtype RequestData = RequestData (ForeignPtr RequestData)
foreign import ccall "soup_request_data_get_type"
    c_soup_request_data_get_type :: IO GType

type instance ParentTypes RequestData = RequestDataParentTypes
type RequestDataParentTypes = '[Request, GObject.Object, Gio.Initable]

instance GObject RequestData where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_soup_request_data_get_type
    

class GObject o => RequestDataK o
instance (GObject o, IsDescendantOf RequestData o) => RequestDataK o

toRequestData :: RequestDataK o => o -> IO RequestData
toRequestData = unsafeCastTo RequestData

noRequestData :: Maybe RequestData
noRequestData = Nothing

type instance AttributeList RequestData = RequestDataAttributeList
type RequestDataAttributeList = ('[ '("session", RequestSessionPropertyInfo), '("uri", RequestUriPropertyInfo)] :: [(Symbol, *)])

type instance SignalList RequestData = RequestDataSignalList
type RequestDataSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


