
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Soup.Objects.RequestFile
    ( 

-- * Exported types
    RequestFile(..)                         ,
    RequestFileK                            ,
    toRequestFile                           ,
    noRequestFile                           ,


 -- * Methods
-- ** requestFileGetFile
    requestFileGetFile                      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Soup.Types
import GI.Soup.Callbacks
import qualified GI.GObject as GObject
import qualified GI.Gio as Gio

newtype RequestFile = RequestFile (ForeignPtr RequestFile)
foreign import ccall "soup_request_file_get_type"
    c_soup_request_file_get_type :: IO GType

type instance ParentTypes RequestFile = RequestFileParentTypes
type RequestFileParentTypes = '[Request, GObject.Object, Gio.Initable]

instance GObject RequestFile where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_soup_request_file_get_type
    

class GObject o => RequestFileK o
instance (GObject o, IsDescendantOf RequestFile o) => RequestFileK o

toRequestFile :: RequestFileK o => o -> IO RequestFile
toRequestFile = unsafeCastTo RequestFile

noRequestFile :: Maybe RequestFile
noRequestFile = Nothing

type instance AttributeList RequestFile = RequestFileAttributeList
type RequestFileAttributeList = ('[ '("session", RequestSessionPropertyInfo), '("uri", RequestUriPropertyInfo)] :: [(Symbol, *)])

type instance SignalList RequestFile = RequestFileSignalList
type RequestFileSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method RequestFile::get_file
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Soup" "RequestFile", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Soup" "RequestFile", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Gio" "File"
-- throws : False
-- Skip return : False

foreign import ccall "soup_request_file_get_file" soup_request_file_get_file :: 
    Ptr RequestFile ->                      -- _obj : TInterface "Soup" "RequestFile"
    IO (Ptr Gio.File)


requestFileGetFile ::
    (MonadIO m, RequestFileK a) =>
    a ->                                    -- _obj
    m Gio.File
requestFileGetFile _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- soup_request_file_get_file _obj'
    checkUnexpectedReturnNULL "soup_request_file_get_file" result
    result' <- (wrapObject Gio.File) result
    touchManagedPtr _obj
    return result'


