
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Soup.Objects.RequestHTTP
    ( 

-- * Exported types
    RequestHTTP(..)                         ,
    RequestHTTPK                            ,
    toRequestHTTP                           ,
    noRequestHTTP                           ,


 -- * Methods
-- ** requestHTTPGetMessage
    requestHTTPGetMessage                   ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Soup.Types
import GI.Soup.Callbacks
import qualified GI.GObject as GObject
import qualified GI.Gio as Gio

newtype RequestHTTP = RequestHTTP (ForeignPtr RequestHTTP)
foreign import ccall "soup_request_http_get_type"
    c_soup_request_http_get_type :: IO GType

type instance ParentTypes RequestHTTP = RequestHTTPParentTypes
type RequestHTTPParentTypes = '[Request, GObject.Object, Gio.Initable]

instance GObject RequestHTTP where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_soup_request_http_get_type
    

class GObject o => RequestHTTPK o
instance (GObject o, IsDescendantOf RequestHTTP o) => RequestHTTPK o

toRequestHTTP :: RequestHTTPK o => o -> IO RequestHTTP
toRequestHTTP = unsafeCastTo RequestHTTP

noRequestHTTP :: Maybe RequestHTTP
noRequestHTTP = Nothing

type instance AttributeList RequestHTTP = RequestHTTPAttributeList
type RequestHTTPAttributeList = ('[ '("session", RequestSessionPropertyInfo), '("uri", RequestUriPropertyInfo)] :: [(Symbol, *)])

type instance SignalList RequestHTTP = RequestHTTPSignalList
type RequestHTTPSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method RequestHTTP::get_message
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "Soup" "RequestHTTP", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "Soup" "RequestHTTP", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "Soup" "Message"
-- throws : False
-- Skip return : False

foreign import ccall "soup_request_http_get_message" soup_request_http_get_message :: 
    Ptr RequestHTTP ->                      -- _obj : TInterface "Soup" "RequestHTTP"
    IO (Ptr Message)


requestHTTPGetMessage ::
    (MonadIO m, RequestHTTPK a) =>
    a ->                                    -- _obj
    m Message
requestHTTPGetMessage _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- soup_request_http_get_message _obj'
    checkUnexpectedReturnNULL "soup_request_http_get_message" result
    result' <- (wrapObject Message) result
    touchManagedPtr _obj
    return result'


